#include "gadget.h"

namespace tadah_fussy
{
  using std::string;
  using std::vector;
  using std::cout;

  namespace string_lib
  {
    /*
      CharCopy : string ѿ s  char* ѿ c ؤѴ

      size  c Υɽ
    */
    void CharCopy( const string& s, char* c, size_t size )
    {
      assert( c != nullptr );

      if ( s.length() == 0 || size == 0 ) return;

      string::size_type i = ( s.length() + 1 > size ) ? size - 1 : s.length();
      s.copy( c, i );
      c[i] = 0;
    }

    /*
      Trim : ʸ st ξüˤʸ
    */
    string Trim( const string& st )
    {
      string::size_type s, e; // ʸʳʸϡλ

      for ( s = 0 ; s < st.length() ; s++ )
        if ( ! isspace( st[s] ) )
          break;

      if ( s == st.length() )
        return( "" );

      for ( e = st.length() - 1 ; e > 0 ; e-- )
        if ( ! isspace( st[e] ) )
          break;

      return( st.substr( s, e - s + 1 ) );
    }

    /*
      Compare : ʸ s1, s2 

      ignoreCase  true ʤʸʸΰ㤤̵뤹

       : s1 < s2 ... -1 ; s1 > s2 ... 1 ; s1 = s2 ... 0
    */
    int8_t Compare( const string& s1, const string& s2, bool ignoreCase )
    {
      auto p1 = s1.begin();
      auto p2 = s2.begin();

      while ( p1 != s1.end() && p2 != s2.end() ) {
        unsigned char c1 = *p1++;
        unsigned char c2 = *p2++;

        if ( ignoreCase ) {
          c1 = std::toupper( c1 );
          c2 = std::toupper( c2 );
        }

        if ( c1 != c2 ) return( ( c1 < c2 ) ? -1 : 1 );
      }

      return( ( s1.size() == s2.size() ) ? 0 :
              ( ( s1.size() < s2.size() ) ? -1 : 1 ) );
    }

    /*
      Split : ʸ s ʸ c Ƕڤꡢret ݻ
    */
    bool Split( const string& s, char c, vector< string >* ret )
    {
      if ( ret == 0 ) return( false );
      ret->clear();

      string::size_type i = 0;
      while ( i < s.length() ) {
        string::size_type j = s.find( c, i );
        if ( j == string::npos ) {
          ret->push_back( s.substr( i ) );
          break;
        }
        //if ( i == 0 || i < j )
	ret->push_back( s.substr( i, j - i ) );
        i = j + 1;
      }

      return( true );
    }

    /*
      Join : ʸΥ٥ vecStr ʸ c ղäʤϢ뤹

      Ϣ뤷̤ ret ݻ
    */
    bool Join( const vector< string >& vecStr, char c, string* ret )
    {
      if ( ret == 0 ) return( false );
      ret->erase();

      for ( vector< string >::const_iterator i = vecStr.begin() ;
            i != vecStr.end() ; ++i ) {
        *ret += *i;
        *ret += c;
      }

      return( true );
    }

    /*
      GetDateTimeFormat :  time ʸѴ֤
    */
    string GetDateTimeFormat( time_t time )
    {
      struct tm tm;
      std::ostringstream oss;
      oss.fill( '0' );
      //char c[4 + 2 * 5 + 5 + 1];	// YYYY/MM/DD hh:mm:ss\0

      localtime_r( &time, &tm );
      //sprintf( c, "%04d/%02d/%02d %02d:%02d:%02d", tm.tm_year + 1900, tm.tm_mon + 1,
      //         tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec );

      oss.width( 4 ); oss << tm.tm_year + 1900;
      oss.width( 0 ); oss << "/";
      oss.width( 2 ); oss << tm.tm_mon + 1;
      oss.width( 0 ); oss << "/";
      oss.width( 2 ); oss << tm.tm_mday;
      oss.width( 0 ); oss << " ";
      oss.width( 2 ); oss << tm.tm_hour;
      oss.width( 0 ); oss << ":";
      oss.width( 2 ); oss << tm.tm_min;
      oss.width( 0 ); oss << ":";
      oss.width( 2 ); oss << tm.tm_sec;

      return( oss.str() );
    }

    /* CharArray : ʸɤ */

    /* 󥹥ȥ饯 */

    /*
      ԡʸ s ꤷƹ
    */
    CharArray::CharArray( const string& s )
    {
      cp_ = new char[s.length() + 1];
      s.copy( cp_, string::npos );
      cp_[s.length()] = '\0';
    }

    /*
      ԡ󥹥ȥ饯
    */
    CharArray::CharArray( const CharArray& c )
    {
      cp_ = new char[c.size() + 1];
      strcpy( cp_, c.cp_ );
      //cp_[c.size()] = '\0';
    }

    /*
      黻Ҥ¿
    */
    CharArray& CharArray::operator=( const CharArray& c )
    {
      if ( this == &c ) return( *this );

      delete[] cp_;

      cp_ = new char[c.size() + 1];
      strcpy( cp_, c.cp_ );
      //cp_[c.size()] = '\0';

      return( *this );
    }

  } // namespace string_lib

} // namespace tadah_fussy
