#include "gtk++.hpp"

namespace tadah_fussy
{
  namespace gtk
  {
    gint32 FileChooser::run( GtkWindow* top, GtkFileChooserAction action,
                             const std::string& title, const std::string& acceptBtn, const std::string& cancelBtn )
    {
      GtkWidget* dialog = gtk_file_chooser_dialog_new
      (
        title.c_str(), top, action,
        cancelBtn.c_str(), GTK_RESPONSE_CANCEL,
        acceptBtn.c_str(), GTK_RESPONSE_ACCEPT,
        NULL
      );

      if ( ! currentDir_.empty() )
        gtk_file_chooser_set_current_folder( GTK_FILE_CHOOSER( dialog ), currentDir_.c_str() );
      gint res = gtk_dialog_run( GTK_DIALOG( dialog ) );

      if ( res == GTK_RESPONSE_ACCEPT ) {
        GtkFileChooser* chooser = GTK_FILE_CHOOSER( dialog );
        gchar* gc = gtk_file_chooser_get_filename( chooser );
        if ( gc != nullptr ) {
          currentFile_ = gc;
          g_free( gc );
        }
        gc = gtk_file_chooser_get_current_folder( chooser );
        if ( gc != nullptr ) {
          currentDir_ = gc;
          g_free( gc );
        }
      }

      gtk_widget_destroy( dialog );

      return( res );
    }

  } // namespace gtk

} // namespace tadah_fussy